import Family from '../models/family';
import Unit from '../models/unit';
import { byGender, relToNode, withId } from '../utils';
import { setDefaultUnitShift } from '../utils/setDefaultUnitShift';
import getChildUnits from './getChildUnits';
export default (store) => {
    return (parentIDs, type = 'root', isMain = false) => {
        const family = new Family(store.getNextId(), type, isMain);
        const parents = parentIDs.map(id => store.getNode(id));
        if (family.main)
            parents.sort(byGender(store.root.gender));
        family.pUnits.push(new Unit(family.id, parents));
        let children;
        if (parents.length === 1) {
            children = parents[0].children.map(relToNode(store));
        }
        else {
            const firstParent = parents[0];
            const secondParent = parents[1];
            children = firstParent.children
                .filter(rel => secondParent.children.find(withId(rel.id)))
                .map(relToNode(store));
        }
        children.forEach(child => {
            getChildUnits(store, family.id, child).forEach(unit => {
                family.cUnits.push(unit);
            });
        });
        setDefaultUnitShift(family);
        return family;
    };
};
//# sourceMappingURL=byParents.js.map