import { SIZE } from '../constants';
import { prop } from './index';
const middle = (values) => {
    return (values[0] + values[values.length - 1]) / 2;
};
export const arrangeParentUnit = (family) => {
    const pUnit = family.pUnits[0];
    if (!pUnit)
        return;
    const children = pUnit.nodes[0].children.map(prop('id'));
    const shifts = family.cUnits.reduce((result, unit) => {
        const index = unit.nodes.findIndex(node => children.includes(node.id));
        if (index !== -1)
            result.push(unit.shift + (index * SIZE));
        return result;
    }, []);
    pUnit.shift = Math.floor(middle(shifts) - (family.pCount - 1));
};
//# sourceMappingURL=arrangeParentUnit.js.map