export const prop = (name) => (item) => item[name];
export const withId = (id) => (item) => item.id === id;
export const withType = (...types) => (item) => types.includes(item.type);
export const withSameIDs = (target) => (unit) => target.ids.join('') === unit.ids.join('');
export const flat = (items, item) => items.concat(item);
export const unique = (item, index, arr) => arr.indexOf(item) === index;
export const inAscOrder = (v1, v2) => v1 - v2;
export const pipe = (...fus) => (init) => fus.reduce((res, fn) => fn(res), init);
export const relToNode = (store) => (rel) => store.getNode(rel.id);
export const min = (arr) => Math.min.apply(null, arr);
export const max = (arr) => Math.max.apply(null, arr);
export function toMap(items) {
    return new Map(items.map((item) => [item.id, Object.assign({}, item)]));
}
export function hasDiffParents(node) {
    return node.parents.map(prop('type')).filter(unique).length > 1;
}
export function byGender(target) {
    return (a, b) => (b.gender !== target) ? -1 : 0;
}
//# sourceMappingURL=index.js.map