import { min, prop } from './index';
import { arrangeParentUnit } from './arrangeParentUnit';
const arrangeInOrder = (units) => {
    units.forEach((unit, idx, self) => (unit.shift = idx === 0 ? 0 : self[idx - 1].right));
};
const correctShift = (value) => {
    return (unit) => unit.shift += value * -1;
};
export const setDefaultUnitShift = (family) => {
    arrangeInOrder(family.pUnits);
    arrangeInOrder(family.cUnits);
    arrangeParentUnit(family);
    const start = min([
        ...family.pUnits.map(prop('shift')),
        ...family.cUnits.map(prop('shift')),
    ]);
    if (start !== 0) {
        const corrector = correctShift(start);
        family.pUnits.forEach(corrector);
        family.cUnits.forEach(corrector);
    }
};
//# sourceMappingURL=setDefaultUnitShift.js.map